#version 450
 
struct PerFrameUniforms
{
    mat4 gViewMat4;
    mat4 gViewProjectionMat4;
    mat4 gCameraMat4;
    mat4 gCameraNoHeadTrackingMat4;
    mat4 gPrevViewProjectionMat4;
    mat4 gThisToPrevViewProjectionMat4;
    mat4 gInverseViewMat4;
    mat4 gInverseProjectionMat4;
    mat4 gInverseProjectionSCMat4;
    mat4 gInverseViewProjectionMat4;
    vec4 gInverseWorldUpMatVec4[3];
    vec3 gViewPositionVec3;
    float gfTime;
    vec3 gVREyeInfoVec3;
    float gfPrevTime;
    vec4 gClipPlanesVec4;
    vec4 gMBlurSettingsVec4;
    vec3 gDeJitterVec3;
    int giFrameIndex;
    vec4 gTaaSettingsVec4;
    vec4 gTessSettingsVec4;
    vec4 gShellsSettingsVec4;
    vec4 gFrameBufferSizeVec4;
    vec4 gFoVValuesVec4;
    vec4 gShadowSizeVec4;
    vec3 gShadowProjScaleVec3;
    int giDisableAmbientAllowed;
    vec4 gShadowFadeParamVec4;
};

struct CommonPerMeshUniforms
{
    vec4 gPlanetPositionVec4;
    mat4 gWorldMat4;
    mat4 gWorldNormalMat4;
    float gfFadeValue;
    vec4 gLightColourVec4;
    vec4 gLightCustomParamsVec4;
    mat4 gWorldMotionMat4;
    mat4 gInverseModelMat4;
};

struct CustomPerMaterialUniforms
{
    vec4 gImposterDataVec4;
    vec4 gTileBlendScalesVec4;
    vec4 gHueOverlayParamsVec4;
    vec4 gSaturationOverlayParamsVec4;
    vec4 gValueOverlayParamsVec4;
    vec4 gTerrainColour1Vec4;
    vec4 gTerrainColour2Vec4;
    vec4 gMaterialParamsVec4;
    vec4 gMaterialColourVec4;
    vec4 gMaterialSFXVec4;
    vec4 gMaterialSFXColVec4;
    vec4 gSunPositionVec4;
};

struct CustomPerMeshUniforms
{
    vec4 gUVScrollStepVec4;
    vec4 gCustomParams01Vec4;
    vec4 gCustomParams02Vec4;
    vec4 gObjectColourVec4;
};

struct UniformBuffer
{
    PerFrameUniforms mpPerFrame;
    CommonPerMeshUniforms mpCommonPerMesh;
    CustomPerMaterialUniforms mpCustomPerMaterial;
    CustomPerMeshUniforms mpCustomPerMesh;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
layout(set = 0, binding = 45, std140) uniform Vk3DParams
{
    vec4 stereo;
    vec4 custom_params;
} vk3d_params;

layout(set = 0, binding = 0, std140) uniform lUniforms_BLK
{
    UniformBuffer lUniforms;
} _502;

layout(set = 1, binding = 1) uniform sampler2D gFadeNoiseMap;
layout(set = 1, binding = 2) uniform sampler2D gBufferMap;
layout(set = 1, binding = 0) uniform sampler2D gDiffuseMap;

layout(location = 0) in VertexBlock
{
    vec4 mTexCoordsVec4;
    vec4 mWorldPositionVec3_mfSpare;
    vec3 mTangentSpaceNormalVec3;
    vec4 mScreenSpacePositionVec4;
    flat vec3 mfFadeValueForInstance_mfLodIndex_mfShearMotionLength;
} In;

layout(location = 0) out vec4 out_color0;
layout(location = 1) out vec4 out_color1;
layout(location = 2) out vec4 out_color2;
layout(location = 3) out vec4 out_color3;

vec4 _1283;

void main()
{
    if (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x < 1.0)
    {
        vec3 _892 = floor(In.mWorldPositionVec3_mfSpare.xyz);
        vec3 _894 = fract(In.mWorldPositionVec3_mfSpare.xyz);
        vec4 _914 = textureLod(gFadeNoiseMap, (_892.xy + (vec2(37.0, 17.0) * _892.z)) + ((_894 * _894) * (vec3(3.0) - (_894 * 2.0))).xy, 0.0);
        float _915 = _914.x;
        if (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x < 0.0)
        {
            if ((1.0 - _915) > (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x + 2.0))
            {
                discard;
            }
        }
        else
        {
            if (_915 > In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x)
            {
                discard;
            }
        }
    }
    vec2 _956 = ((In.mScreenSpacePositionVec4.xy / vec2(In.mScreenSpacePositionVec4.w)) * 0.5) + vec2(0.5);
    vec2 _1059 = (_956 * 2.0) - vec2(1.0);
    vec4 _1248 = vec4(_1059.x, _1059.y, _1283.z, _1283.w);
    _1248.z = (((_502.lUniforms.mpPerFrame.gClipPlanesVec4.x * _502.lUniforms.mpPerFrame.gClipPlanesVec4.y) / (texture(gBufferMap, vec2(_956.x, 1.0 - _956.y)).x * _502.lUniforms.mpPerFrame.gClipPlanesVec4.y)) - _502.lUniforms.mpPerFrame.gClipPlanesVec4.x) / (_502.lUniforms.mpPerFrame.gClipPlanesVec4.y - _502.lUniforms.mpPerFrame.gClipPlanesVec4.x);

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
_1248.x -= vk3d_params.stereo.x * (1 - vk3d_params.stereo.y * _1248.z * 10); 
    vec4 _1250 = _1248;
    _1250.w = 1.0;
    vec4 _1069 = _502.lUniforms.mpPerFrame.gInverseViewProjectionMat4 * _1250;
    vec3 _985 = (_502.lUniforms.mpCommonPerMesh.gInverseModelMat4 * vec4((_1069.xyz / vec3(_1069.w)).xyz + _502.lUniforms.mpPerFrame.gViewPositionVec3, 1.0)).xyz + vec3(0.5);
    float _988 = 1.0 - _985.y;
    vec3 _1254 = _985;
    _1254.y = _988;
    float _991 = _985.x;
    bool _992 = _991 < 0.0;
    bool _999;
    if (!_992)
    {
        _999 = _991 >= 1.0;
    }
    else
    {
        _999 = _992;
    }
    bool _1006;
    if (!_999)
    {
        _1006 = _988 < 0.0;
    }
    else
    {
        _1006 = _999;
    }
    bool _1013;
    if (!_1006)
    {
        _1013 = _988 >= 1.0;
    }
    else
    {
        _1013 = _1006;
    }
    bool _1020;
    if (!_1013)
    {
        _1020 = _985.z < 0.0;
    }
    else
    {
        _1020 = _1013;
    }
    bool _1027;
    if (!_1020)
    {
        _1027 = _985.z >= 1.0;
    }
    else
    {
        _1027 = _1020;
    }
    if (_1027)
    {
        discard;
    }
    vec4 _624 = texture(gDiffuseMap, _1254.xy);
    float _630 = _624.w * _502.lUniforms.mpCustomPerMaterial.gMaterialColourVec4.w;
    if (_630 < 9.9999997473787516355514526367188e-05)
    {
        discard;
    }
    vec4 _1268 = _1283;
    _1268.x = 0.0;
    vec4 _1270 = _1268;
    _1270.y = sqrt(_502.lUniforms.mpCustomPerMaterial.gMaterialParamsVec4.x * 0.5);
    vec4 _1272 = _1270;
    _1272.z = clamp(_502.lUniforms.mpCustomPerMaterial.gMaterialParamsVec4.z, 0.0, 1.0);
    vec4 _1274 = _1272;
    _1274.w = 0.0;
    out_color0 = vec4(_624.xyz, _630);
    out_color1 = vec4(0.0);
    out_color2 = vec4(0.0);
    out_color3 = _1274;
}


